% basis NMF
% idx_NMF_AR=[2,6,11,17,29]; % AR3,200
% idx_NMF_olivetti=[2,3,4,8,35]; %200
% idx_NMF_yale=[3,6,7,17,22]; %150
%h1=figure;
for i=1:48
    X=reshape(basis_vecs_NA(:,i),32,32);
    %X=reshape(basis_vecs_NMF(:,idx_NMF_olivetti(i)),32,32);
    %X=reshape(basis_vecs_NMF(:,idx_NMF_yale(i)),32,32);
    k=mat2gray(X);
    subplot(6,8,i)
    imshow(1-k)
    axis tight
end

% basis LNMF
idx_LNMF_AR=[1,2,3,4,40]; %AR3,200
idx_LNMF_olivetti=[5,9,50,57,60]; %200
idx_LNMF_yale=[33,34,37,38,39]; %150
idx_orth_LNMF_AR=[9,17,19,21,38];
%h2=figure;
for i=1:5
    X=reshape(basis_vecs_LNMF(:,idx_LNMF_AR(i)),32,32);
    %X=reshape(basis_vecs_LNMF(:,idx_LNMF_olivetti(i)),32,32);
    %X=reshape(basis_vecs_LNMF(:,idx_LNMF_yale(i)),32,32);
    %X=reshape(orth_basis_vecs_LNMF(:,idx_orth_LNMF_AR(i)),32,32);
    k=mat2gray(X);
    subplot(3,5,10+i)
    imshow(1-k)
end

% basis ICA
idx_ICA_AR=[4,5,21,25,29]; %AR3,200
idx_ICA_olivetti=[5,28,31,34,35]; %200
idx_ICA_yale=[5,10,11,24,33]; %150
%h3=figure;
for i=1:5
    %X=reshape(basis_vecs_ICA_IMAX(:,idx_ICA_AR(i)),32,32);
    %X=reshape(basis_vecs_ICA_IMAX(:,idx_ICA_olivetti(i)),32,32);
    X=reshape(basis_vecs_ICA_IMAX(:,idx_ICA_yale(i)),32,32);
    k=mat2gray(X);
    subplot(3,5,10+i)
    imshow(1-k)
end

% basis NA
idx_NA_AR=[10,15,18,30,40]; %AR3,50
idx_NA_olivetti=[5,11,16,18,27]; %200
idx_NA_yale=[6,7,25,28,40]; %150
%h4=figure;
for i=1:5
    %X=reshape(basis_vecs_NA(:,idx_NA_AR(i)),32,32);
    %X=reshape(basis_vecs_NA(:,idx_NA_olivetti(i)),32,32);
    X=reshape(basis_vecs_NA(:,idx_NA_yale(i)),32,32);
    k=mat2gray(X);
    subplot(3,5,10+i)
    imshow(1-k)
end

%==============
for i=1:40
    figure
    x=reshape(orth_basis_vecs_LNMF(:,i),32,32);
    k=mat2gray(x);
    imshow(1-k)
end

%==============
% error rates

% expression
a=[34.1 41 41.4 44.8];
b=[28.2 40.6 45.7 57.7];
c=[22.6 36.7 48.7 50];
d=[67.5 69.6 70.5 70.9];
e=[36.3 35 35.9 38];
subplot(2,3,1)
x=[50 100 150 200];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Expression - AR04')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

% illumination
a=[56.4 75.6 72.6 91.4];
b=[40.1 65.8 70.9 71.3];
c=[41.4	38	67.5 68.8];
d=[97.4	98.3 99.5 100];
e=[56.8	70.9 73.5 79];
subplot(2,3,2)
x=[50 100 150 200];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Illumination - AR07')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

% occlusion-eyeglasses
a=[4.2 8.1 9.4 8.1];
b=[3 3.8 7.2 11.1];
c=[2.1 4.2	5.5	8.5];
d=[41	46.1	49.1	50.4];
e=[9.4	4.2	7.2	3];
subplot(2,3,3)
x=[50 100 150 200];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Occlusion/eyeglasses - AR10')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

% occlusion-scarf
a=[3.4	4.2	5.9	6.8];
b=[2.5	3	3.8	3.4];
c=[3	2.1	3.4	2.1];
d=[41.4	47.8	51.2	54.2];
e=[2.5	7.7	4.2	5.9];
subplot(2,3,4)
x=[50 100 150 200];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Occlusion/scarf - AR13')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

% olivetti
a=[91.8	93.5	93	92.9];
b=[92.3	95.1	94.4	94.3];
c=[92.8	94.5	93.8	93.5];
d=[93.4	94.3	93.2	93.7];
e=[82	74.1	71.9	55];
subplot(2,3,5)
x=[50 100 150 200];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Pose - Olivetti')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

% yale
a=[84	100	94.6];
b=[82.6	100	90.6];
c=[85.3	99.3	92];
d=[100	100	100];
e=[80.6	91.3	78];
subplot(2,3,6)
x=[50 100 150];
plot(x,a,'-x')
xlabel('No. of basis vectors')
title('Expression - Yale')
hold
plot(x,b,'-o')
plot(x,c,':')
plot(x,d,'-')
plot(x,e,'-^')

%=======================================================
% histogram of the intensity values for the basis vectors
clear all
load AR03_200.mat
basis_vecs_NMF=norm_data(basis_vecs_NMF,[0 255]);
x=reshape(basis_vecs_NMF,1024*200,1);
basis_vecs_LNMF=norm_data(basis_vecs_LNMF,[0 255]);
y=reshape(basis_vecs_LNMF,1024*200,1);
load AR03_50.mat
basis_vecs_NMF=norm_data(basis_vecs_NMF,[0 255]);
x1=reshape(basis_vecs_NMF,1024*50,1);
basis_vecs_LNMF=norm_data(basis_vecs_LNMF,[0 255]);
y1=reshape(basis_vecs_LNMF,1024*50,1);

load AR3_IMAX_200.mat
basis_vecs_ICA_IMAX=norm_data(abs(basis_vecs_ICA_IMAX),[0 255]);
z=reshape(basis_vecs_ICA_IMAX,1024*200,1);
load bas_AR03_scNMF_200.asc
basis_vecs_scNMF=norm_data(abs(bas_AR03_scNMF_200),[0 255]);
v=reshape(basis_vecs_scNMF,1920*200,1);
%basis_vecs_NA=norm_data(basis_vecs_NA,[0 255]);
%v=reshape(basis_vecs_NA,1024*200,1);
load AR3_IMAX_50.mat
basis_vecs_ICA_IMAX=norm_data(abs(basis_vecs_ICA_IMAX),[0 255]);
z1=reshape(basis_vecs_ICA_IMAX,1024*50,1);
load bas_AR03_scNMF_50.asc
basis_vecs_scNMF=norm_data(abs(bas_AR03_scNMF_50),[0 255]);
v1=reshape(basis_vecs_scNMF,1920*50,1);
%basis_vecs_NA=norm_data(basis_vecs_NA,[0 255]);
%v1=reshape(basis_vecs_NA,1024*50,1);

subplot(2,2,1)
h1=semilogy(hist(x,256),'k-');
set(h1,'LineWidth',2);
hold
semilogy(hist(x1,256),'k:')
xlabel('Gray level intensity')
title('NMF')
subplot(2,2,2)
h2=semilogy(hist(y,256),'k-');
set(h2,'LineWidth',2);
hold
semilogy(hist(y1,256),'k:')
xlabel('Gray level intensity')
title('LNMF')
subplot(2,2,3)
h3=semilogy(hist(z,256),'k-');
set(h3,'LineWidth',2);
hold
semilogy(hist(z1,256),'k:')
xlabel('Gray level intensity')
title('ICA-InfoMax')
subplot(2,2,4)
h4=semilogy(hist(v,256),'k-');
set(h4,'LineWidth',2);
hold
semilogy(hist(v1,256),'k:')
xlabel('Gray level intensity')
title('NMFsc')

%====================
% AR image database
subplot(4,4,2)
x=reshape(AR01(:,1),48,40);
imshow(x)
title('AR01_1')
subplot(4,4,3)
x=reshape(AR01(:,2),48,40);
imshow(x)
title('AR01_2')
subplot(4,4,5)
x=reshape(AR02(:,1),48,40);
imshow(x)
title('AR02')
subplot(4,4,6)
x=reshape(AR03(:,1),48,40);
imshow(x)
title('AR03')
subplot(4,4,7)
x=reshape(AR04(:,1),48,40);
imshow(x)
title('AR04')
subplot(4,4,8)
x=reshape(AR05(:,1),48,40);
imshow(x)
title('AR05')
subplot(4,4,9)
x=reshape(AR06(:,1),48,40);
imshow(x)
title('AR06')
subplot(4,4,10)
x=reshape(AR07(:,1),48,40);
imshow(x)
title('AR07')
subplot(4,4,11)
x=reshape(AR08(:,1),48,40);
imshow(x)
title('AR08')
subplot(4,4,12)
x=reshape(AR09(:,1),48,40);
imshow(x)
title('AR09')
subplot(4,4,13)
x=reshape(AR10(:,1),48,40);
imshow(x)
title('AR10')
subplot(4,4,14)
x=reshape(AR11(:,1),48,40);
imshow(x)
title('AR11')
subplot(4,4,15)
x=reshape(AR12(:,1),48,40);
imshow(x)
title('AR12')
subplot(4,4,16)
x=reshape(AR13(:,1),48,40);
imshow(x)
title('AR13')

% Occlusion Olivetti: NMF, LNMF, ICA-FICA, ICA-IMAX, NA
% pca=50
a=[86.4 52.8 28.9 19.9];
b=[88.2 62.6 41.9 20.6];
%c=[89.9 58.7 29 15.7];
d=[88.4 60.9 36.7 31.6];
%e=[69 42.3 27.1 15.1];
t=[5 10 15 20];
subplot(2,2,1)
plot(t,a,'k-')
hold
plot(t,b,'k-o')
%plot(t,c,'-x');
%plot(t,e,':');
plot(t,d,'k-s');
hold off
axis([5 20 0 100])
xlabel('Patch size')
title('No. basis vectors = 50')

% pca=100
a=[87.5 57.1 39.2 25];
b=[91.7 63 32.4 12.5];
%c=[89 56.4 28.3 15.5];
d=[89.2 63.6 39 31.6];
%e=[71.4 48.6 21 22.9];
t=[5 10 15 20];
subplot(2,2,2)
plot(t,a,'k-')
hold
plot(t,b,'k-o')
%plot(t,c,'-x');
%plot(t,e,':');
plot(t,d,'k-s');
hold off
xlabel('Patch size')
title('No. basis vectors = 100')

% pca=150
a=[87.1 61.4 42 30.4];
b=[93.1 60.9 26.6 12.1];
%c=[89.4 56.5 27.3 15.3];
d=[89.6 64.1 39.4 32.1];
%e=[53.1 36.2 24.1 18.2];
t=[5 10 15 20];
subplot(2,2,3)
plot(t,a,'k-')
hold
plot(t,b,'k-o')
%plot(t,c,'-x');
%plot(t,e,':');
plot(t,d,'k-s');
hold off
xlabel('Patch size')
title('No. basis vectors = 150')

% pca=200
a=[85.4 63.2 46.5 33.5];
b=[91.5 58 22.8 10.5];
%c=[88.8 56.4 26.6 15];
d=[89.5 64.9 40.2 31.9];
%e=[35.6 19.4 14.9 10.9];
t=[5 10 15 20];
subplot(2,2,4)
plot(t,a,'k-')
hold
plot(t,b,'k-o')
%plot(t,c,'-x');
%plot(t,e,':');
plot(t,d,'k-s');
hold off
xlabel('Patch size')
title('No. basis vectors = 200')


%=================
% Compute tangents
%=================
% params.TangComp='dif1';

x1=reshape(tango1(:,8),32,32);

image13=imresize(image1,3,'bicubic');
x13=imresize(x1,3,'bicubic');

figure
k1=mat2gray(image13);
imshow(k1)

figure
x23=image13+0.5*x13;
k2=mat2gray(x23);
imshow(k2);

y1=reshape(tango1(:,7),32,32);
y13=imresize(y1,3,'bicubic');

figure
y23=image13+0.5*y13;
k3=mat2gray(y23);
imshow(k3);

x33=image13+x13;
y33=image13+y13;

% params.TangComp='standard';

x1=reshape(tango1(:,4),32,32);

image13=imresize(image1,3,'bicubic');
x13=imresize(x1,3,'bicubic');

figure
k1=mat2gray(image13);
imshow(k1)

figure
x23=image13+x13;
k2=mat2gray(x23);
imshow(k2);
x33=image13+2*x13;

figure
y23=image13-x13;
k3=mat2gray(y23);
imshow(k3);
y33=image13-2*x13;

% plot figure
img=imresize(image,3,'bicubic');

x_all=[];
x_all=[x_all reshape(x33,96*96,1)];
x_all=[x_all reshape(x23,96*96,1)];
x_all=[x_all reshape(img,96*96,1)];
x_all=[x_all reshape(y23,96*96,1)];
x_all=[x_all reshape(y33,96*96,1)];
x_all=x_all-min(min(x_all));
x_all=x_all/max(max(x_all));
%[x_all,flag_err,p_norm]=process('norm',x_all',[0 1]);
%x_all=x_all';
visual(1-x_all,1,5)

