clear all

% Load data and normalize magnitudes
load data_olivetti.asc
input=process('norm',data_olivetti',[0 1])';
clear data_olivetti

% Setup parameters
hit_rate_all=[];
no_trials=5;
no_train=5;
no_total=10;
d_type='euclidean'; %'fisher'
thresh=0.05;
no_persons=40;
flag_fisher=1;

% Perform multiple experiments using distinct Train/Test datasets
for i=1:no_trials
    sprintf('Iteration=%d',i)
    [data_train_pca,data_test_pca,score_all,eigvalues_all,avg_img_allpers,V_pca,data_train,data_test,data_train_reconstruct,fisher_train,fisher_test,fisher_basis]=eigen_faces(input,no_persons,no_train,no_total,thresh,flag_fisher);
	[idx_all,d_all,hit_rate,data_test_reconstruct]=classify_images(data_test,data_train_pca,no_train,no_total,avg_img_allpers,V_pca,d_type,fisher_train,fisher_basis,flag_fisher);
    hit_rate_all=[hit_rate_all hit_rate];
end
